0f36bdda377e5a0f4b02ea8a89534cbac68f4df1
[metaproxy-moved-to-github.git] / debian / metaproxy.init
1 #! /bin/sh
2 ### BEGIN INIT INFO
3 # Provides:          metaproxy
4 # Required-Start:    $local_fs $remote_fs $network $named $time
5 # Required-Stop:     $local_fs $remote_fs
6 # Default-Start:     2 3 4 5
7 # Default-Stop:      0 1 6
8 # Short-Description: Controls the metaproxy daemon
9 # Description:       Controls the Metaproxy daemon /usr/bin/metaproxy .
10 ### END INIT INFO
11
12 # Do NOT "set -e"
13
14 # PATH should only include /usr/* if it runs after the mountnfs.sh script
15 PATH=/sbin:/usr/sbin:/bin:/usr/bin
16 NAME=metaproxy
17 DAEMON=/usr/bin/$NAME
18 DAEMON_OPTS="-h"
19 PIDFILE=/var/run/$NAME.pid
20 SCRIPTNAME=/etc/init.d/$NAME
21
22 # Exit if the package is not installed
23 [ -x "$DAEMON" ] || exit 0
24
25 # Read configuration variable file if it is present
26 [ -r /etc/default/$NAME ] && . /etc/default/$NAME
27
28 # Load the VERBOSE setting and other rcS variables
29 . /lib/init/vars.sh
30
31 # Define LSB log_* functions.
32 # Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
33 . /lib/lsb/init-functions
34
35 #
36 # Function that starts the daemon/service
37 #
38 do_start()
39 {
40         # Return
41         #   0 if daemon has been started
42         #   1 if daemon was already running
43         #   2 if daemon could not be started
44         start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
45                 || return 1
46         start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
47                 $DAEMON_OPTS \
48                 || return 2
49         # Add code here, if necessary, that waits for the process to be ready
50         # to handle requests from services started subsequently which depend
51         # on this one.  As a last resort, sleep for some time.
52 }
53
54 #
55 # Function that stops the daemon/service
56 #
57 do_stop()
58 {
59         # Return
60         #   0 if daemon has been stopped
61         #   1 if daemon was already stopped
62         #   2 if daemon could not be stopped
63         #   other if a failure occurred
64         start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE
65         RETVAL="$?"
66         [ "$RETVAL" = 2 ] && return 2
67         # Wait for children to finish too if this is a daemon that forks
68         # and if the daemon is only ever run from this initscript.
69         # If the above conditions are not satisfied then add some other code
70         # that waits for the process to drop all resources that could be
71         # needed by services started subsequently.  A last resort is to
72         # sleep for some time.
73         #start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
74         #[ "$?" = 2 ] && return 2
75         # Many daemons don't delete their pidfiles when they exit.
76         rm -f $PIDFILE
77         return "$RETVAL"
78 }
79
80 #
81 # Function that sends a SIGHUP to the daemon/service
82 #
83 do_reload() {
84         #
85         # If the daemon can reload its configuration without
86         # restarting (for example, when it is sent a SIGHUP),
87         # then implement that here.
88         #
89         start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
90         return 0
91 }
92
93 case "$1" in
94   start)
95         [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
96         do_start
97         case "$?" in
98                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
99                 2) [ "$VERBOSE" = no ] && \
100                                 log_daemon_msg "Starting $DESC" "$NAME"
101                         log_end_msg 1 
102                 ;;
103         esac
104         ;;
105   stop)
106         [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
107         do_stop
108         case "$?" in
109                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
110                 2) [ "$VERBOSE" = no ] && \
111                                 log_daemon_msg "Stopping $DESC" "$NAME"
112                         log_end_msg 1 
113                 ;;
114         esac
115         ;;
116   #reload|force-reload)
117         #
118         # If do_reload() is not implemented then leave this commented out
119         # and leave 'force-reload' as an alias for 'restart'.
120         #
121         #log_daemon_msg "Reloading $DESC" "$NAME"
122         #do_reload
123         #log_end_msg $?
124         #;;
125   restart|force-reload)
126         #
127         # If the "reload" option is implemented then remove the
128         # 'force-reload' alias
129         #
130         log_daemon_msg "Restarting $DESC" "$NAME"
131         do_stop
132         case "$?" in
133           0|1)
134                 do_start
135                 case "$?" in
136                         0) log_end_msg 0 ;;
137                         1) log_end_msg 1 ;; # Old process is still running
138                         *) log_end_msg 1 ;; # Failed to start
139                 esac
140                 ;;
141           *)
142                 # Failed to stop
143                 log_end_msg 1
144                 ;;
145         esac
146         ;;
147   *)
148         #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
149         echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
150         exit 3
151         ;;
152 esac
153
154 :